#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>

static void button_handler(GtkWidget* widget, gpointer user_data)
{
    g_print("Button pressed!\n");
}

static void activate(GtkApplication* app, gpointer user_data)
{
    GtkWidget* window = gtk_application_window_new(app);
    gtk_window_set_title(GTK_WINDOW(window), "MatemaTeak");
    gtk_window_set_default_size(GTK_WINDOW(window), 1600, 900);

    GtkWidget* button_box = gtk_button_box_new(GTK_ORIENTATION_HORIZONTAL);
    gtk_container_add(GTK_CONTAINER(window), button_box);

    GtkWidget* button = gtk_button_new_with_label("Do stuff");
    g_signal_connect(button, "clicked", G_CALLBACK(button_handler), NULL);
    g_signal_connect_swapped(
        button, "clicked", G_CALLBACK(gtk_widget_destroy), window
    );
    gtk_container_add(GTK_CONTAINER(button_box), button);

    gtk_widget_show_all(window);
}

int main(int argc, char** argv)
{
    GtkApplication* app = gtk_application_new(
        "dk.simonfj20.matemateak", G_APPLICATION_DEFAULT_FLAGS
    );
    g_signal_connect(app, "activate", G_CALLBACK(activate), NULL);
    int status = g_application_run(G_APPLICATION(app), argc, argv);
    g_object_unref(app);
    return status;
}
